<template>
  <div>
    <my-header :small-format="true" />

    <div
      class="container mx-auto md:py-3 px-2 md:px-4 flex flex-col lg:flex-row gap-x-5 gap-y-1"
    >
      <aside
        class="flex-none lg:block lg:sticky top-8 rounded-md w-full lg:w-80 lg:h-screen flex-col justify-between mt-3 lg:pb-10 lg:px-8 overflow-y-auto dark:text-slate-100"
      >
        <logo class="hidden lg:block" />
        <button
          @click="toggleFilters"
          class="w-full inline-flex lg:hidden bg-primary text-white px-4 py-2 justify-center"
        >
          <svg
            xmlns="http://www.w3.org/2000/svg"
            width="24"
            height="24"
            fill="none"
            viewBox="0 0 24 24"
            stroke="currentColor"
            strokeWidth="{2}"
          >
            <path
              strokeLinecap="round"
              strokeLinejoin="round"
              d="M3 4a1 1 0 011-1h16a1 1 0 011 1v2.586a1 1 0 01-.293.707l-6.414 6.414a1 1 0 00-.293.707V17l-4 4v-6.586a1 1 0 00-.293-.707L3.293 7.293A1 1 0 013 6.586V4z"
            />
          </svg>
          <span v-if="!filtersPanelOpened">{{ $gettext('Hide filters') }}</span>
          <span v-else>{{ $gettext('Show filters') }}</span>
        </button>
        <form
          @submit.prevent="doNewSearch"
          :class="{ hidden: filtersPanelOpened }"
          class="lg:block mt-2"
        >
          <p class="sr-only">{{ $gettext('Type') }}</p>
          <ul
            class="font-medium text-gray-900 dark:text-slate-100 space-y-4 py-6 border-y border-gray-200"
          >
            <li
              v-for="content in contentTypeMapping($gettext)"
              :key="content.contentType"
              class="flex gap-2"
            >
              <svg
                aria-hidden="true"
                v-if="content.contentType === ContentType.ALL"
                width="24"
                height="24"
                stroke-width="1.5"
                viewBox="0 0 24 24"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path
                  d="M15.5 15.5L19 19"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
                <path
                  d="M5 11C5 14.3137 7.68629 17 11 17C12.6597 17 14.1621 16.3261 15.2483 15.237C16.3308 14.1517 17 12.654 17 11C17 7.68629 14.3137 5 11 5C7.68629 5 5 7.68629 5 11Z"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
              </svg>

              <svg
                aria-hidden="true"
                v-if="content.contentType === ContentType.EVENTS"
                width="24"
                height="24"
                stroke-width="1.5"
                viewBox="0 0 24 24"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path
                  d="M15 4V2M15 4V6M15 4H10.5M3 10V19C3 20.1046 3.89543 21 5 21H19C20.1046 21 21 20.1046 21 19V10H3Z"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
                <path
                  d="M3 10V6C3 4.89543 3.89543 4 5 4H7"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
                <path
                  d="M7 2V6"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
                <path
                  d="M21 10V6C21 4.89543 20.1046 4 19 4H18.5"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
              </svg>

              <svg
                aria-hidden="true"
                v-if="content.contentType === ContentType.GROUPS"
                width="24"
                height="24"
                stroke-width="1.5"
                viewBox="0 0 24 24"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path
                  d="M1 20V19C1 15.134 4.13401 12 8 12V12C11.866 12 15 15.134 15 19V20"
                  stroke="currentColor"
                  stroke-linecap="round"
                />
                <path
                  d="M13 14V14C13 11.2386 15.2386 9 18 9V9C20.7614 9 23 11.2386 23 14V14.5"
                  stroke="currentColor"
                  stroke-linecap="round"
                />
                <path
                  d="M8 12C10.2091 12 12 10.2091 12 8C12 5.79086 10.2091 4 8 4C5.79086 4 4 5.79086 4 8C4 10.2091 5.79086 12 8 12Z"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
                <path
                  d="M18 9C19.6569 9 21 7.65685 21 6C21 4.34315 19.6569 3 18 3C16.3431 3 15 4.34315 15 6C15 7.65685 16.3431 9 18 9Z"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                />
              </svg>

              <router-link
                :to="{
                  ...$route,
                  query: { ...$route.query, contentType: content.contentType },
                }"
              >
                {{ content.label }}
              </router-link>
            </li>
          </ul>

          <div
            class="py-4 border-b border-gray-200"
            v-show="contentType !== 'GROUPS'"
          >
            <label
              for="toggle-example"
              class="flex relative items-center cursor-pointer"
            >
              <input
                type="checkbox"
                id="toggle-example"
                v-model="isOnline"
                class="sr-only"
              />
              <span
                class="w-11 h-6 bg-gray-200 rounded-full border border-gray-200 toggle-bg dark:bg-gray-700 dark:border-gray-600"
              ></span>
              <span
                class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"
                >{{ $gettext('Online events') }}</span
              >
            </label>
          </div>

          <filter-section
            v-show="contentType !== 'GROUPS'"
            v-model:opened="searchFilterSectionsOpenStatus.eventDate"
            :title="$gettext('Event date')"
          >
            <template #options>
              <fieldset class="flex flex-col">
                <legend class="sr-only">{{ $gettext('Event date') }}</legend>
                <div
                  v-for="eventStartDateRangeOption in eventStartDateRanges(
                    $gettext
                  )"
                  :key="eventStartDateRangeOption.id"
                >
                  <input
                    :id="eventStartDateRangeOption.id"
                    v-model="eventStartDateRange"
                    type="radio"
                    name="eventStartDateRange"
                    :value="eventStartDateRangeOption.id"
                    class="w-4 h-4 border-gray-300 focus:ring-2 focus:ring-blue-300 dark:focus:ring-blue-600 dark:focus:bg-blue-600 dark:bg-gray-700 dark:border-gray-600"
                  />
                  <label
                    :for="eventStartDateRangeOption.id"
                    class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"
                    >{{ eventStartDateRangeOption.label }}</label
                  >
                </div>
              </fieldset>
            </template>
            <template #preview>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
              >
                {{ eventStartDateRangesLabel(eventStartDateRange, $gettext) }}
              </span>
            </template>
          </filter-section>

          <filter-section
            v-show="formLocation.name && formLocation.lon && !isOnline"
            v-model:opened="searchFilterSectionsOpenStatus.eventDistance"
            :title="$gettext('Distance')"
          >
            <template #options>
              <fieldset class="flex flex-col">
                <legend class="sr-only">{{ $gettext('Distance') }}</legend>
                <div
                  v-for="distanceOption in eventDistance($gettext, $ngettext)"
                  :key="distanceOption.id"
                >
                  <input
                    :id="distanceOption.id"
                    v-model="distance"
                    type="radio"
                    name="eventDistance"
                    :value="distanceOption.id"
                    class="w-4 h-4 border-gray-300 focus:ring-2 focus:ring-blue-300 dark:focus:ring-blue-600 dark:focus:bg-blue-600 dark:bg-gray-700 dark:border-gray-600"
                  />
                  <label
                    :for="distanceOption.id"
                    class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"
                    >{{ distanceOption.label }}</label
                  >
                </div>
              </fieldset>
            </template>
            <template #preview>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
              >
                {{ eventDistanceLabel(distance, $gettext, $ngettext) }}
              </span>
            </template>
          </filter-section>

          <filter-section
            v-show="contentType !== 'GROUPS'"
            v-model:opened="searchFilterSectionsOpenStatus.eventCategory"
            :title="$gettext('Categories')"
          >
            <template #options>
              <fieldset class="flex flex-col">
                <legend class="sr-only">{{ $gettext('Categories') }}</legend>
                <div
                  v-for="category in eventCategories($gettext)"
                  :key="category.id"
                >
                  <input
                    :id="category.id"
                    v-model="categoryOneOf"
                    type="checkbox"
                    name="category"
                    :value="category.id"
                    class="w-4 h-4 border-gray-300 focus:ring-2 focus:ring-blue-300 dark:focus:ring-blue-600 dark:focus:bg-blue-600 dark:bg-gray-700 dark:border-gray-600"
                  />
                  <label
                    :for="category.id"
                    class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"
                    >{{ category.label }}</label
                  >
                </div>
              </fieldset>
            </template>
            <template #preview>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-if="categoryOneOf.length > 2"
              >
                {{
                  $gettext('%{numberOfCategories} selected', {
                    numberOfCategories: categoryOneOf.length.toString(),
                  })
                }}
              </span>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-else-if="categoryOneOf.length > 0"
              >
                {{
                  listShortDisjunctionFormatter(
                    categoryOneOf.map((category) =>
                      eventCategoryLabel(category, $gettext)
                    )
                  )
                }}
              </span>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-else-if="categoryOneOf.length === 0"
              >
                {{ $pgettext('Categories', 'All') }}
              </span>
            </template>
          </filter-section>

          <filter-section
            v-show="contentType !== 'GROUPS'"
            v-model:opened="searchFilterSectionsOpenStatus.eventStatus"
            :title="$gettext('Event status')"
          >
            <template #options>
              <fieldset class="flex flex-col">
                <legend class="sr-only">{{ $gettext('Event status') }}</legend>
                <div
                  v-for="eventStatusOption in eventStatuses($gettext)"
                  :key="eventStatusOption.id"
                >
                  <input
                    :id="eventStatusOption.id"
                    v-model="statusOneOf"
                    type="checkbox"
                    name="eventStatus"
                    :value="eventStatusOption.id"
                    class="w-4 h-4 border-gray-300 focus:ring-2 focus:ring-blue-300 dark:focus:ring-blue-600 dark:focus:bg-blue-600 dark:bg-gray-700 dark:border-gray-600"
                  />
                  <label
                    :for="eventStatusOption.id"
                    class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"
                    >{{ eventStatusOption.label }}</label
                  >
                </div>
              </fieldset>
            </template>
            <template #preview>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-if="statusOneOf.length === eventStatuses($gettext).length"
              >
                {{ $pgettext('Statuses', 'All') }}
              </span>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-else-if="statusOneOf.length > 0"
              >
                {{
                  listShortDisjunctionFormatter(
                    statusOneOf.map((status) =>
                      eventStatusesLabel(status, $gettext)
                    )
                  )
                }}
              </span>
            </template>
          </filter-section>

          <filter-section
            v-model:opened="searchFilterSectionsOpenStatus.eventLanguage"
            :title="$gettext('Languages')"
          >
            <template #options>
              <fieldset class="flex flex-col">
                <legend class="sr-only">{{ $gettext('Languages') }}</legend>
                <div
                  v-for="language in eventLanguages($gettext)"
                  :key="language.id"
                >
                  <input
                    :id="language.id"
                    type="checkbox"
                    name="eventStartDateRange"
                    :value="language.id"
                    v-model="languageOneOf"
                    class="w-4 h-4 border-gray-300 focus:ring-2 focus:ring-blue-300 dark:focus:ring-blue-600 dark:focus:bg-blue-600 dark:bg-gray-700 dark:border-gray-600"
                  />
                  <label
                    :for="language.id"
                    class="ml-3 text-sm font-medium text-gray-900 dark:text-gray-300"
                    >{{ language.label }}</label
                  >
                </div>
              </fieldset>
            </template>
            <template #preview>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-if="languageOneOf.length > 2"
              >
                {{
                  $gettext('%{numberOfLanguages} selected', {
                    numberOfLanguages: languageOneOf.length.toString(),
                  })
                }}
              </span>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-else-if="languageOneOf.length > 0"
              >
                {{
                  listShortDisjunctionFormatter(
                    languageOneOf.map((lang) =>
                      eventLanguagesLabel(lang, $gettext)
                    )
                  )
                }}
              </span>
              <span
                class="bg-blue-100 text-blue-800 text-sm font-semibold p-0.5 rounded dark:bg-blue-200 dark:text-blue-800 grow-0"
                v-else-if="languageOneOf.length === 0"
              >
                {{ $pgettext('Languages', 'All') }}
              </span>
            </template>
          </filter-section>

          <!--

            <div class="">
              <label v-translate class="font-bold" for="host">Mobilizon instance</label>

              <input
                id="host"
                v-model="formHost"
                type="text"
                name="host"
                placeholder="mobilizon.fr"
                class="dark:text-black md:max-w-fit w-full"
              />
            </div>

            <div class="">
              <label v-translate class="inline font-bold" for="tagsAllOf">All of these tags</label>
              <button
                v-if="formTagsAllOf.length !== 0"
                v-translate
                class="text-sm ml-2"
                @click="resetField('tagsAllOf')"
              >
                Reset
              </button>

              <vue-tags-input
                v-model="formTagAllOf"
                :placeholder="tagsPlaceholder"
                :tags="formTagsAllOf"
                @tags-changed="(newTags) => (formTagsAllOf = newTags)"
              />
            </div>

            <div>
              <div>
                <label v-translate class="inline font-bold" for="tagsOneOf">One of these tags</label>
                <button
                  v-if="formTagsOneOf.length !== 0"
                  v-translate
                  class="text-sm ml-2"
                  @click="resetField('tagsOneOf')"
                >
                  Reset
                </button>
              </div>

              <vue-tags-input
                v-model="formTagOneOf"
                :placeholder="tagsPlaceholder"
                :tags="formTagsOneOf"
                @tags-changed="(newTags) => (formTagsOneOf = newTags)"
              />
            </div>-->

          <div v-if="userInstance.instanceName" class="py-6">
            <p
              v-html="
                $gettext(
                  'Redirection activated to the instance %{instance} (%{host})',
                  {
                    instance: `<strong>${userInstance.instanceName}</strong>`,
                    host: hostFromInstanceRedirectURI(
                      userInstance.instanceRedirectURI
                    ),
                  },
                  true
                )
              "
            />
            <button
              class="text-blue-700 hover:text-white border border-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg px-3 py-2 text-xs text-center dark:border-blue-500 dark:text-blue-500 dark:hover:text-white dark:hover:bg-blue-600 dark:focus:ring-blue-800"
              @click="clearUserInstance"
            >
              {{ $gettext('Clear') }}
            </button>
          </div>

          <div class="sr-only">
            <button
              class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center mr-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800"
              type="submit"
            >
              {{ $gettext('Apply filters') }}
            </button>
          </div>

          <button
            @click="toggleFilters"
            class="w-full inline-flex lg:hidden bg-primary text-white px-4 py-2 justify-center"
          >
            <svg
              xmlns="http://www.w3.org/2000/svg"
              width="24"
              height="24"
              fill="none"
              viewBox="0 0 24 24"
              stroke="currentColor"
              strokeWidth="{2}"
            >
              <path
                strokeLinecap="round"
                strokeLinejoin="round"
                d="M3 4a1 1 0 011-1h16a1 1 0 011 1v2.586a1 1 0 01-.293.707l-6.414 6.414a1 1 0 00-.293.707V17l-4 4v-6.586a1 1 0 00-.293-.707L3.293 7.293A1 1 0 013 6.586V4z"
              />
            </svg>
            <span>{{ $gettext('Hide filters') }}</span>
          </button>
        </form>
      </aside>

      <main class="flex-1">
        <search-fields
          class="mt-3"
          v-model:location="formLocation"
          :search="search"
          @update:search="debounceSearch"
          @submit="doNewSearch"
        />
        <setup-instance-suggestion />

        <div id="result-container">
          <div class="dark:text-slate-100 mb-3">
            <div class="flex flex-wrap justify-between items-baseline">
              <div
                id="results-anchor"
                class="hidden sm:block dark:text-slate-100"
              >
                <p v-if="counts.total === 0 || counts.total === null">
                  <span v-if="contentType === 'EVENTS'">{{
                    $gettext('No events found')
                  }}</span>
                  <span v-else-if="contentType === 'GROUPS'">{{
                    $gettext('No groups found')
                  }}</span>
                  <span v-else>{{ $gettext('No results found') }}</span>
                </p>
                <p v-else>
                  <span v-if="contentType === 'EVENTS'">
                    {{
                      $ngettext(
                        'One event found',
                        '%{eventsCount} events found',
                        counts.events,
                        { eventsCount: counts.events }
                      )
                    }}
                  </span>
                  <span v-else-if="contentType === 'GROUPS'">
                    {{
                      $ngettext(
                        'One group found',
                        '%{groupsCount} groups found',
                        counts.groups,
                        { groupsCount: counts.groups }
                      )
                    }}
                  </span>
                  <span v-else>
                    {{
                      $ngettext(
                        'One result found',
                        '%{resultsCount} result found',
                        counts.total,
                        { resultsCount: counts.total }
                      )
                    }}
                  </span>
                </p>
              </div>

              <div
                class="w-full md:w-auto justify-between flex flex-wrap md:flex-nowrap gap-2 items-center"
              >
                <Listbox v-model="sort" v-if="mode === ViewMode.LIST">
                  <div class="relative mt-1 w-full">
                    <ListboxButton
                      class="relative inline-flex justify-center w-full md:w-auto px-5 py-2.5 text-sm font-medium text-white bg-primary rounded-md hover:bg-opacity-30 focus:outline-none focus-visible:ring-2 focus-visible:ring-white focus-visible:ring-opacity-75"
                    >
                      <span class="block truncate">
                        {{ $gettext('Sort') }}
                      </span>
                      <svg
                        class="flex-shrink-0 -mr-1 ml-1 h-5 w-5 text-gray-400 group-hover:text-gray-500"
                        xmlns="http://www.w3.org/2000/svg"
                        viewBox="0 0 20 20"
                        fill="currentColor"
                        aria-hidden="true"
                      >
                        <path
                          fill-rule="evenodd"
                          d="M5.293 7.293a1 1 0 011.414 0L10 10.586l3.293-3.293a1 1 0 111.414 1.414l-4 4a1 1 0 01-1.414 0l-4-4a1 1 0 010-1.414z"
                          clip-rule="evenodd"
                        />
                      </svg>
                    </ListboxButton>
                    <transition
                      leave-active-class="transition duration-100 ease-in"
                      leave-from-class="opacity-100"
                      leave-to-class="opacity-0"
                    >
                      <ListboxOptions
                        class="absolute z-[500] right-0 origin-top-right w-full md:w-60 py-1 mt-1 overflow-auto text-base bg-white rounded-md shadow-lg max-h-60 ring-1 ring-black ring-opacity-5 focus:outline-none sm:text-sm"
                      >
                        <ListboxOption
                          v-slot="{ active, selected }"
                          v-for="sortOption in sortOptions(
                            $gettext,
                            contentType
                          )"
                          :key="sortOption.key"
                          :value="sortOption.key"
                          as="template"
                        >
                          <li
                            :class="[
                              active
                                ? 'text-amber-900 bg-mbz-yellow'
                                : 'text-gray-900',
                              'cursor-default select-none relative py-2 px-3',
                            ]"
                          >
                            <span
                              :class="[
                                selected ? 'font-medium' : 'font-normal',
                                'block truncate cursor-pointer',
                              ]"
                              >{{ sortOption.label }}</span
                            >
                          </li>
                        </ListboxOption>
                      </ListboxOptions>
                    </transition>
                  </div>
                </Listbox>
                <div class="inline w-full md:w-auto">
                  <button
                    class="w-full justify-center text-white bg-primary focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center inline-flex items-center mr-2 dark:focus:ring-blue-800"
                    @click="
                      () =>
                        (mode =
                          mode === ViewMode.MAP ? ViewMode.LIST : ViewMode.MAP)
                    "
                  >
                    <span
                      v-if="mode === ViewMode.LIST"
                      class="flex gap-0.5 items-center"
                    >
                      <svg
                        width="24"
                        height="24"
                        stroke-width="1.5"
                        viewBox="0 0 24 24"
                        fill="none"
                        xmlns="http://www.w3.org/2000/svg"
                      >
                        <path
                          d="M9 19L3.78974 20.7368C3.40122 20.8663 3 20.5771 3 20.1675L3 5.43246C3 5.1742 3.16526 4.94491 3.41026 4.86325L9 3M9 19L15 21M9 19L9 3M15 21L20.5897 19.1368C20.8347 19.0551 21 18.8258 21 18.5675L21 3.83246C21 3.42292 20.5988 3.13374 20.2103 3.26325L15 5M15 21L15 5M15 5L9 3"
                          stroke="currentColor"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                        />
                      </svg>
                      {{ $gettext('Map') }}
                    </span>
                    <span v-else class="flex gap-0.5 items-center">
                      <svg
                        width="24"
                        height="24"
                        stroke-width="1.5"
                        viewBox="0 0 24 24"
                        fill="none"
                        xmlns="http://www.w3.org/2000/svg"
                      >
                        <path
                          d="M8 6L20 6"
                          stroke="currentColor"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                        />
                        <path
                          d="M4 6.01L4.01 5.99889"
                          stroke="currentColor"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                        />
                        <path
                          d="M4 12.01L4.01 11.9989"
                          stroke="currentColor"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                        />
                        <path
                          d="M4 18.01L4.01 17.9989"
                          stroke="currentColor"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                        />
                        <path
                          d="M8 12L20 12"
                          stroke="currentColor"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                        />
                        <path
                          d="M8 18L20 18"
                          stroke="currentColor"
                          stroke-linecap="round"
                          stroke-linejoin="round"
                        />
                      </svg>

                      {{ $gettext('List') }}
                    </span>
                  </button>
                </div>
              </div>
            </div>
          </div>

          <div v-show="mode === ViewMode.LIST">
            <div v-if="loading">
              <skeleton-event-result
                v-for="i in [...Array(4).keys()]"
                class="scroll-ml-6 snap-center shrink-0 my-4"
                :key="i"
                v-show="loading"
              />
            </div>
            <div v-else-if="results.length > 0">
              <div
                v-for="result in results"
                :key="getResultKey(result)"
                class="pr-1"
              >
                <event-result
                  v-if="isEvent(result)"
                  :event="result"
                ></event-result>

                <group-result
                  v-else-if="isGroup(result)"
                  :group="result"
                ></group-result>

                <post-result v-else :post="result"></post-result>
              </div>
            </div>
            <div v-else>
              <div
                class="dark:text-slate-100 relative p-4 md:p-8 border border-gray-200 rounded-lg"
              >
                <template v-if="contentType === 'EVENTS'">
                  <p
                    class="text-xl md:text-2xl font-medium"
                    v-if="search.length > 0"
                    v-html="
                      $gettext(
                        'Your search for %{searchTerm} did not match any events.',
                        { searchTerm: boldSearchTerm },
                        true
                      )
                    "
                  />
                  <p v-else class="text-xl md:text-2xl font-medium">
                    {{ $gettext('Your search did not match any events.') }}
                  </p>
                </template>
                <template v-else-if="contentType === 'GROUPS'">
                  <p
                    class="text-xl md:text-2xl font-medium"
                    v-if="search.length > 0"
                    v-html="
                      $gettext(
                        'Your search for %{searchTerm} did not match any groups.',
                        { searchTerm: boldSearchTerm },
                        true
                      )
                    "
                  />
                  <p v-else class="text-xl md:text-2xl font-medium">
                    {{ $gettext('Your search did not match any groups.') }}
                  </p>
                </template>
                <template v-else>
                  <p
                    v-if="search.length > 0"
                    class="text-xl md:text-2xl font-medium"
                    v-html="
                      $gettext(
                        'Your search for %{searchTerm} did not match any results.',
                        { searchTerm: boldSearchTerm },
                        true
                      )
                    "
                  />
                  <p v-else class="text-xl md:text-2xl font-medium">
                    {{ $gettext('Your search did not match any results.') }}
                  </p>
                </template>
                <p class="my-2 text-start text-sm">
                  {{ $gettext('Suggestions:') }}
                </p>
                <ul class="list-disc list-inside text-start text-sm">
                  <li>
                    {{
                      $gettext(
                        'Make sure that all words are spelled correctly.'
                      )
                    }}
                  </li>
                  <li>{{ $gettext('Try different keywords.') }}</li>
                  <li>{{ $gettext('Try more general keywords.') }}</li>
                  <li>{{ $gettext('Try fewer keywords.') }}</li>
                  <li>{{ $gettext('Change the filters.') }}</li>
                </ul>
              </div>
            </div>

            <pagination
              v-if="searchDone && maxPage >= page && page >= 1 && maxPage > 1"
              class="text-center flex items-center justify-center gap-x-2 my-6 md:my-8"
              :current-page="page"
              :max-page="maxPage"
              :pages="pages"
            />
          </div>
          <suspense>
            <event-marker-map
              v-if="mode === ViewMode.MAP"
              :form-data="formData"
            />
            <template #fallback>
              {{ $gettext('Loading map') }}
            </template>
          </suspense>
        </div>
      </main>
    </div>
  </div>
</template>

<script setup lang="ts">
  import SetupInstanceSuggestion from '../components/SetupInstanceSuggestion.vue'
  import EventResult from '../components/result/EventResult.vue'
  import GroupResult from '../components/result/GroupResult.vue'
  import PostResult from '../components/result/PostResult.vue'
  import FilterSection from '../components/filters/FilterSection.vue'
  import Pagination from '../components/Pagination.vue'
  import SearchFields from '../components/search/SearchFields.vue'
  import {
    computed,
    defineAsyncComponent,
    inject,
    onMounted,
    reactive,
    ref,
    watch,
  } from 'vue'
  import { ResultList } from '../../../server/types/search-query/common-search.model'
  import { EnhancedEvent, EventStatus } from '../../../server/types/event.model'
  import { EnhancedGroup } from '../../../server/types/group.model'
  import {
    buildEventSearchQuery,
    buildGroupSearchQuery,
  } from '@/query/buildQuery'
  import {
    contentTypeMapping,
    eventCategories,
    eventCategoryLabel,
    eventDistance,
    eventDistanceLabel,
    eventLanguages,
    eventLanguagesLabel,
    eventStartDateRanges,
    eventStartDateRangesLabel,
    eventStatuses,
    eventStatusesLabel,
    sortOptions,
    SortValues,
  } from '@/query/constants'
  import { searchEvents, searchGroups } from '@/shared/search'
  import Nprogress from 'nprogress'
  import { EnhancedPost } from '../../../server/types/post.model'
  import { Locale } from 'date-fns'
  import { ContentType } from '../models/search-url.model'
  import { useGettext } from 'vue3-gettext'
  import {
    Listbox,
    ListboxButton,
    ListboxOption,
    ListboxOptions,
  } from '@headlessui/vue'
  import {
    booleanTransformer,
    enumTransformer,
    floatTransformer,
    integerTransformer,
    useRouteQuery,
    RouteQueryTransformer,
  } from 'vue-use-route-query'
  import SkeletonEventResult from '../components/result/SkeletonEventResult.vue'
  import { useHead } from '@vueuse/head'
  import { LocationType } from '../../../shared/user-location.model'
  import { listShortDisjunctionFormatter } from '../plugins/listFormat'
  import { ServerConfig } from '../../../shared/server-config.model'
  import { UserInstanceData } from '../../../shared/remote-instance'
  import {
    clearUserInstanceData,
    hostFromInstanceRedirectURI,
  } from '../plugins/preferredInstance'
  import Logo from '../components/Logo.vue'
  import { boostLanguagesQuery } from '@/query/misc'

  const EventMarkerMap = defineAsyncComponent(
    () => import('../components/EventMarkerMap.vue')
  )

  const MyHeader = defineAsyncComponent(
    () => import('../components/Header.vue')
  )

  const arrayTransformer: RouteQueryTransformer<string[]> = {
    fromQuery(query) {
      return query.split(',')
    },
    toQuery(value) {
      return value.join(',')
    },
  }

  const loading = ref(false)

  const { $gettext, $ngettext } = useGettext()

  const search = useRouteQuery('search', '')
  const sort = useRouteQuery(
    'sort',
    SortValues.MATCH_DESC,
    enumTransformer(SortValues)
  )
  const page = useRouteQuery('page', 1, integerTransformer)

  enum ViewMode {
    LIST = 'list',
    MAP = 'map',
  }

  const mode = useRouteQuery('mode', ViewMode.LIST, enumTransformer(ViewMode))

  const contentType = useRouteQuery(
    'contentType',
    ContentType.ALL,
    enumTransformer(ContentType)
  )
  const eventStartDateRange = useRouteQuery('eventStartDateRange', 'future')
  const distance = useRouteQuery('distance', '10_km')
  const categoryOneOf = useRouteQuery('categoryOneOf', [], arrayTransformer)
  const isOnline = useRouteQuery('isOnline', false, booleanTransformer)
  const statusOneOf = useRouteQuery(
    'statusOneOf',
    [EventStatus.CONFIRMED],
    arrayTransformer
  )

  const languageOneOf = useRouteQuery('languageOneOf', [], arrayTransformer)
  const lon = useRouteQuery('lon', undefined, floatTransformer)
  const lat = useRouteQuery('lat', undefined, floatTransformer)
  const locationName = useRouteQuery('locationName', null)

  languageOneOf.value = boostLanguagesQuery($gettext).slice(0, 1)

  const { userLocation, updateUserLocation } = inject<{
    userLocation: LocationType
    updateUserLocation: (newLocation: LocationType) => void
  }>('userLocation')

  const formLocation = computed<LocationType>({
    get() {
      return { lon: lon.value, lat: lat.value, name: locationName.value }
    },
    set(newValue: LocationType) {
      lat.value = newValue.lat
      lon.value = newValue.lon
      locationName.value = newValue.name
    },
  })

  const formData = computed(() => ({
    search: search.value,
    sort: sort.value,
    page: page.value,
    contentType: contentType.value,
    eventStartDateRange: eventStartDateRange.value,
    distance: distance.value,
    categoryOneOf: categoryOneOf.value,
    isOnline: isOnline.value,
    statusOneOf: statusOneOf.value,
    languageOneOf: languageOneOf.value,
    locationData: formLocation.value,
  }))

  /**
   * If we change anything in the search criteria, we need to reset the page to 1
   */
  watch(formData, (newFormData, oldFormData) => {
    if (newFormData.page === oldFormData.page) {
      page.value = 1
    }
  })

  watch(formData, doSearch, { deep: true })

  // watch(formData, updateURLFromParams, { deep: true })

  const boldSearchTerm = computed(() => `<b>${search.value}</b>`)

  const searchFilterSectionsOpenStatus = ref({
    eventDate: true,
    eventLanguage: false,
    eventCategory: false,
    eventStatus: false,
    eventDistance: false,
  })

  const pages = ref([])
  const results = ref([])

  const resultsPerEventsPage = 5
  const resultsPerGroupPage = 10

  const counts = reactive({
    total: null,
    groups: null,
    events: null,
  })

  const groupsMaxPage = computed<number>(() =>
    Math.ceil(counts.groups / resultsPerGroupPage)
  )

  const eventsMaxPage = computed<number>(() =>
    Math.ceil(counts.events / resultsPerEventsPage)
  )

  const maxPage = computed<number>(() => {
    switch (contentType.value) {
      case 'EVENTS':
        return Math.min(10, eventsMaxPage.value)
      case 'GROUPS':
        return Math.min(10, groupsMaxPage.value)
      case 'ALL':
      default:
        return Math.min(10, Math.max(groupsMaxPage.value, eventsMaxPage.value))
    }
  })

  const hasStillGroupsResult = computed<boolean>(() => {
    // Not searched yet
    if (counts.groups === null) return true

    return groupsMaxPage.value >= page.value
  })

  const hasStillMoreEventsResults = computed<boolean>(() => {
    // Not searched yet
    if (counts.events === null) return true

    return eventsMaxPage.value >= page.value
  })

  const isGroupOrPostSearchDisabled = computed<boolean>(() => {
    // We can search against host for posts and groups
    // if (host || contentType)
    //   return activeFiltersCount > 1
    //
    // return activeFiltersCount > 0
    return false
  })

  const dateFnsLocale = inject<Locale>('dateFnsLocale')

  const userInstance = inject<UserInstanceData>('userInstance')
  const updateUserInstance =
    inject<(newUserInstance: UserInstanceData) => void>('updateUserInstance')

  const clearUserInstance = () => {
    updateUserInstance({
      instanceName: undefined,
      instanceRedirectURI: undefined,
    })
    clearUserInstanceData()
  }

  async function doSearchEvents(): Promise<ResultList<EnhancedEvent>> {
    // if (!hasStillMoreEventsResults.value) {
    //   return Promise.resolve({ data: [], total: counts.events })
    // }

    const query = buildEventSearchQuery(
      {
        ...formData.value,
        locale: dateFnsLocale,
        resultsPerEventsPage,
      },
      $gettext
    )

    return searchEvents(query)
  }

  function doSearchGroups(): Promise<ResultList<EnhancedGroup>> {
    if (isGroupOrPostSearchDisabled.value) {
      return Promise.resolve({
        data: [],
        total: 0,
      })
    }

    // if (!hasStillGroupsResult.value) {
    //   return Promise.resolve({
    //     data: [],
    //     total: counts.groups,
    //   })
    // }

    const query = buildGroupSearchQuery(
      {
        ...formData.value,
        resultsPerGroupPage,
      },
      $gettext
    )

    console.debug('dosearchgroups', formData.value, query)

    return searchGroups(query)
  }

  const searchDone = ref(false)

  function doNewSearch(): void {
    page.value = 1
    counts.groups = null
    counts.events = null
    counts.total = null

    doSearch()
  }

  async function doSearch() {
    console.debug('do search')
    if (searchDone.value !== true) scrollToTop()

    loading.value = true

    Nprogress.start()

    try {
      // Nprogress.done()

      let eventsResult, groupsResult

      switch (contentType.value) {
        case 'EVENTS':
          eventsResult = await doSearchEvents()
          counts.events = eventsResult.total
          counts.total = eventsResult.total
          results.value = eventsResult.data
          break
        case 'GROUPS':
          groupsResult = await doSearchGroups()
          counts.groups = groupsResult.total
          counts.total = groupsResult.total
          results.value = groupsResult.data
          break
        default:
          ;[eventsResult, groupsResult] = await Promise.all([
            doSearchEvents(),
            doSearchGroups(),
          ])
          counts.total = eventsResult.total + groupsResult.total
          counts.events = eventsResult.total
          counts.groups = groupsResult.total
          results.value = [...groupsResult.data, ...eventsResult.data]
          break
      }

      if (sort.value === SortValues.MATCH_DESC) {
        results.value.sort((r1, r2) => {
          if (r1.score < r2.score) {
            return 1
          } else if (r1.score === r2.score) return 0

          return -1
        })
      }

      buildPages()
      searchDone.value = true
    } catch (err) {
      console.error('Cannot do search.', err)
    } finally {
      loading.value = false
      Nprogress.done()
    }
  }

  function buildPages() {
    pages.value = []

    for (let i = 1; i <= maxPage.value; i++) {
      pages.value.push(i)
    }
  }

  function scrollToTop() {
    window.scrollTo(0, 0)
  }

  function isEvent(result: EnhancedEvent | EnhancedGroup | EnhancedPost) {
    return !!(result as EnhancedEvent).startTime
  }

  function isGroup(result: EnhancedEvent | EnhancedGroup | EnhancedPost) {
    return (result as EnhancedGroup).displayName !== undefined
  }

  function getResultKey(result: EnhancedEvent | EnhancedGroup | EnhancedPost) {
    if (isEvent(result)) return (result as EnhancedEvent).uuid
    if (isGroup(result)) return result.id + (result as EnhancedGroup).id

    throw new Error('Unknown result')
  }

  const filtersPanelOpened = ref(true)

  const toggleFilters = () =>
    (filtersPanelOpened.value = !filtersPanelOpened.value)

  const debounceSearchValue = ref(0)

  const debounceSearch = (searchValue: string) => {
    clearTimeout(debounceSearchValue.value)
    debounceSearchValue.value = window.setTimeout(() => {
      search.value = searchValue
    }, 600)
  }

  const config = inject<ServerConfig>('config')

  const indexName = computed(() => config.searchInstanceName)

  onMounted(async () => {
    await doSearch()
  })

  useHead({
    title: computed(() => {
      if (search.value) {
        return $gettext('%{search} - %{indexName}', {
          search: search.value,
          indexName: indexName.value,
        })
      }
      if (categoryOneOf.value && categoryOneOf.value.length > 0) {
        const formatter = new Intl.ListFormat(undefined, {
          style: 'long',
          type: 'conjunction',
        })
        return $ngettext(
          'Events for category %{category} - %{indexName}',
          'Events for categories %{category} - %{indexName}',
          categoryOneOf.value.length,
          {
            category: formatter.format(
              categoryOneOf.value.map((category) =>
                eventCategoryLabel(category, $gettext)
              )
            ),
            indexName: indexName.value,
          }
        )
      }
      return $gettext('Find events and groups - %{indexName}', {
        indexName: indexName.value,
      })
    }),
    meta: [
      {
        name: `description`,
        content: computed(() => {
          return $gettext('Search results on %{indexName}')
        }),
      },
    ],
  })
</script>
